freedombone-utils-gpg 11KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # gpg functions
  12. #
  13. # License
  14. # =======
  15. #
  16. # Copyright (C) 2016-2017 Bob Mottram <bob@freedombone.net>
  17. #
  18. # This program is free software: you can redistribute it and/or modify
  19. # it under the terms of the GNU Affero General Public License as published by
  20. # the Free Software Foundation, either version 3 of the License, or
  21. # (at your option) any later version.
  22. #
  23. # This program is distributed in the hope that it will be useful,
  24. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  25. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  26. # GNU Affero General Public License for more details.
  27. #
  28. # You should have received a copy of the GNU Affero General Public License
  29. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  30. function gpg_update_mutt {
  31. key_username=$1
  32. if [ ! -f /home/$key_username/.muttrc ]; then
  33. return
  34. fi
  35. CURR_EMAIL_ADDRESS=$key_username@$HOSTNAME
  36. CURR_GPG_ID=$(gpg --homedir=/home/$key_username/.gnupg --list-keys $CURR_EMAIL_ADDRESS | sed -n '2p' | sed 's/^[ \t]*//')
  37. sed -i "s|set pgp_encrypt_only_command.*|set pgp_encrypt_only_command=\"/usr/lib/mutt/pgpewrap gpg --batch --quiet --no-verbose --output - --encrypt --textmode --armor --trust-model always --encrypt-to $CURR_GPG_ID -- -r %r -- %f\"|g" /home/$key_username/.muttrc
  38. sed -i "s|set pgp_encrypt_sign_command.*|set pgp_encrypt_sign_command=\"/usr/lib/mutt/pgpewrap gpg %?p?--passphrase-fd 0? --batch --quiet --no-verbose --textmode --output - --encrypt --sign %?a?-u %a? --armor --trust-model always --encrypt-to $CURR_GPG_ID -- -r %r -- %f\"|g" /home/$key_username/.muttrc
  39. chown $key_username:$key_username /home/$key_username/.muttrc
  40. }
  41. function gpg_import_public_key {
  42. key_username=$1
  43. key_filename=$2
  44. gpg --homedir=/home/$key_username/.gnupg --import $key_filename
  45. gpg_set_permissions $key_username
  46. }
  47. function gpg_import_private_key {
  48. key_username=$1
  49. key_filename=$2
  50. gpg --homedir=/home/$key_username/.gnupg --allow-secret-key-import --import $key_filename
  51. gpg_set_permissions $key_username
  52. }
  53. function gpg_export_public_key {
  54. key_username=$1
  55. key_id=$2
  56. key_filename=$3
  57. chown -R $key_username:$key_username /home/$key_username/.gnupg
  58. su -m root -c "gpg --homedir /home/$key_username/.gnupg --output $key_filename --armor --export $key_id" - $key_username
  59. }
  60. function gpg_export_private_key {
  61. key_username=$1
  62. key_id=$2
  63. key_filename=$3
  64. chown -R $key_username:$key_username /home/$key_username/.gnupg
  65. su -m root -c "gpg --homedir=/home/$key_username/.gnupg --armor --output $key_filename --export-secret-key $key_id" - $key_username
  66. }
  67. function gpg_create_key {
  68. key_username=$1
  69. key_passphrase=$2
  70. gpg_dir=/home/$key_username/.gnupg
  71. echo 'Key-Type: eddsa' > /home/$key_username/gpg-genkey.conf
  72. echo 'Key-Curve: Ed25519' >> /home/$key_username/gpg-genkey.conf
  73. echo 'Subkey-Type: eddsa' >> /home/$key_username/gpg-genkey.conf
  74. echo 'Subkey-Curve: Ed25519' >> /home/$key_username/gpg-genkey.conf
  75. echo "Name-Real: $MY_NAME" >> /home/$key_username/gpg-genkey.conf
  76. echo "Name-Email: $MY_EMAIL_ADDRESS" >> /home/$key_username/gpg-genkey.conf
  77. echo 'Expire-Date: 0' >> /home/$key_username/gpg-genkey.conf
  78. cat /home/$key_username/gpg-genkey.conf
  79. if [ $key_passphrase ]; then
  80. echo "Passphrase: $key_passphrase" >> /home/$key_username/gpg-genkey.conf
  81. else
  82. echo "Passphrase: $PROJECT_NAME" >> /home/$key_username/gpg-genkey.conf
  83. fi
  84. chown $key_username:$key_username /home/$key_username/gpg-genkey.conf
  85. echo $'Generating a new GPG key'
  86. su -m root -c "gpg --homedir /home/$key_username/.gnupg --batch --full-gen-key /home/$key_username/gpg-genkey.conf" - $key_username
  87. chown -R $key_username:$key_username /home/$key_username/.gnupg
  88. KEY_EXISTS=$(gpg_key_exists "$key_username" "$MY_EMAIL_ADDRESS")
  89. if [[ $KEY_EXISTS == "no" ]]; then
  90. echo $"A GPG key for $MY_EMAIL_ADDRESS could not be created"
  91. exit 63621
  92. fi
  93. shred -zu /home/$key_username/gpg-genkey.conf
  94. CURR_GPG_PUBLIC_KEY_ID=$(gpg_pubkey_from_email "$key_username" "$MY_EMAIL_ADDRESS")
  95. if [ ${#CURR_GPG_PUBLIC_KEY_ID} -lt 4 ]; then
  96. echo $"GPG public key ID could not be obtained for $MY_EMAIL_ADDRESS"
  97. exit 825292
  98. fi
  99. gpg_set_permissions $key_username
  100. }
  101. function gpg_delete_key {
  102. key_username=$1
  103. key_id=$2
  104. chown -R $key_username:$key_username /home/$key_username/.gnupg
  105. su -c "gpg --batch --quiet --homedir=/home/$key_username/.gnupg --delete-secret-key $key_id" - $key_username
  106. su -c "gpg --batch --quiet --homedir=/home/$key_username/.gnupg --delete-key $key_id" - $key_username
  107. }
  108. function gpg_set_permissions {
  109. key_username=$1
  110. if [[ "$key_username" != 'root' ]]; then
  111. chmod 700 /home/$key_username/.gnupg
  112. chmod -R 600 /home/$key_username/.gnupg/*
  113. chown -R $key_username:$key_username /home/$key_username/.gnupg
  114. else
  115. chmod 700 /root/.gnupg
  116. chmod -R 600 /root/.gnupg/*
  117. chown -R $key_username:$key_username /root/.gnupg
  118. fi
  119. }
  120. function gpg_reconstruct_key {
  121. key_username=$1
  122. key_interactive=$2
  123. if [ ! -d /home/$key_username/.gnupg_fragments ]; then
  124. return
  125. fi
  126. cd /home/$key_username/.gnupg_fragments
  127. no_of_shares=$(ls -afq keyshare.asc.* | wc -l)
  128. if (( no_of_shares < 4 )); then
  129. if [ $key_interactive ]; then
  130. dialog --title $"Recover Encryption Keys" --msgbox $'Not enough fragments to reconstruct the key' 6 70
  131. else
  132. echo $'Not enough fragments to reconstruct the key'
  133. fi
  134. exit 7348
  135. fi
  136. gfcombine /home/$key_username/.gnupg_fragments/keyshare*
  137. if [ ! "$?" = "0" ]; then
  138. if [ $key_interactive ]; then
  139. dialog --title $"Recover Encryption Keys" --msgbox $'Unable to reconstruct the key' 6 70
  140. else
  141. echo $'Unable to reconstruct the key'
  142. fi
  143. exit 7348
  144. fi
  145. KEYS_FILE=/home/$key_username/.gnupg_fragments/keyshare.asc
  146. if [ ! -f $KEYS_FILE ]; then
  147. if [ $key_interactive ]; then
  148. dialog --title $"Recover Encryption Keys" --msgbox $'Unable to reconstruct the key' 6 70
  149. else
  150. echo $'Unable to reconstruct the key'
  151. fi
  152. exit 52852
  153. fi
  154. gpg --homedir=/home/$key_username/.gnupg --allow-secret-key-import --import $KEYS_FILE
  155. if [ ! "$?" = "0" ]; then
  156. shred -zu $KEYS_FILE
  157. rm -rf /home/$key_username/.tempgnupg
  158. if [ $key_interactive ]; then
  159. dialog --title $"Recover Encryption Keys" --msgbox $'Unable to import gpg key' 6 70
  160. else
  161. echo $'Unable to import gpg key'
  162. fi
  163. exit 96547
  164. fi
  165. shred -zu $KEYS_FILE
  166. gpg_set_permissions $key_username
  167. if [ $key_interactive ]; then
  168. dialog --title $"Recover Encryption Keys" --msgbox $'Key has been reconstructed' 6 70
  169. else
  170. echo $'Key has been reconstructed'
  171. fi
  172. }
  173. function gpg_agent_setup {
  174. gpg_username=$1
  175. if [[ $gpg_username == 'root' ]]; then
  176. if ! grep -q 'GPG_TTY' /root/.bashrc; then
  177. echo '' >> /root/.bashrc
  178. echo 'GPG_TTY=$(tty)' >> /root/.bashrc
  179. echo 'export GPG_TTY' >> /root/.bashrc
  180. fi
  181. if ! grep -q 'use-agent' /root/.gnupg/gpg.conf; then
  182. echo 'use-agent' >> /root/.gnupg/gpg.conf
  183. fi
  184. if ! grep -q 'pinentry-mode loopback' /root/.gnupg/gpg.conf; then
  185. echo 'pinentry-mode loopback' >> /root/.gnupg/gpg.conf
  186. fi
  187. if [ ! -f /root/.gnupg/gpg-agent.conf ]; then
  188. touch /root/.gnupg/gpg-agent.conf
  189. fi
  190. if ! grep -q 'allow-loopback-pinentry' /root/.gnupg/gpg-agent.conf; then
  191. echo 'allow-loopback-pinentry' >> /root/.gnupg/gpg-agent.conf
  192. fi
  193. echo RELOADAGENT | gpg-connect-agent
  194. else
  195. if ! grep -q 'GPG_TTY' /home/$gpg_username/.bashrc; then
  196. echo '' >> /home/$gpg_username/.bashrc
  197. echo 'GPG_TTY=$(tty)' >> /home/$gpg_username/.bashrc
  198. echo 'export GPG_TTY' >> /home/$gpg_username/.bashrc
  199. chown $gpg_username:$gpg_username /home/$gpg_username/.bashrc
  200. fi
  201. if ! grep -q 'use-agent' /home/$gpg_username/.gnupg/gpg.conf; then
  202. echo 'use-agent' >> /home/$gpg_username/.gnupg/gpg.conf
  203. fi
  204. if ! grep -q 'pinentry-mode loopback' /home/$gpg_username/.gnupg/gpg.conf; then
  205. echo 'pinentry-mode loopback' >> /home/$gpg_username/.gnupg/gpg.conf
  206. fi
  207. if [ ! -f /home/$gpg_username/.gnupg/gpg-agent.conf ]; then
  208. touch /home/$gpg_username/.gnupg/gpg-agent.conf
  209. fi
  210. if ! grep -q 'allow-loopback-pinentry' /home/$gpg_username/.gnupg/gpg-agent.conf; then
  211. echo 'allow-loopback-pinentry' >> /home/$gpg_username/.gnupg/gpg-agent.conf
  212. fi
  213. su -c "echo RELOADAGENT | gpg-connect-agent" - $gpg_username
  214. fi
  215. }
  216. function gpg_pubkey_from_email {
  217. key_owner_username=$1
  218. key_email_address=$2
  219. key_id=
  220. if [[ $key_owner_username != "root" ]]; then
  221. key_id=$(su -c "gpg --list-keys $key_email_address" - $key_owner_username | sed -n '2p' | sed 's/^[ \t]*//')
  222. else
  223. key_id=$(gpg --list-keys $key_email_address | sed -n '2p' | sed 's/^[ \t]*//')
  224. fi
  225. echo $key_id
  226. }
  227. function enable_email_encryption_at_rest {
  228. for d in /home/*/ ; do
  229. USERNAME=$(echo "$d" | awk -F '/' '{print $3}')
  230. if [[ $(is_valid_user "$USERNAME") == "1" ]]; then
  231. if grep -q '#| /usr/bin/gpgit.pl' /home/$USERNAME/.procmailrc; then
  232. sed -i 's@#| /usr/bin/gpgit.pl@| /usr/bin/gpgit.pl@g' /home/$USERNAME/.procmailrc
  233. sed -i 's|#:0 f|:0 f|g' /home/$USERNAME/.procmailrc
  234. fi
  235. fi
  236. done
  237. if grep -q '#| /usr/bin/gpgit.pl' /etc/skel/.procmailrc; then
  238. sed -i 's@#| /usr/bin/gpgit.pl@| /usr/bin/gpgit.pl@g' /etc/skel/.procmailrc
  239. sed -i 's|#:0 f|:0 f|g' /etc/skel/.procmailrc
  240. fi
  241. }
  242. function disable_email_encryption_at_rest {
  243. for d in /home/*/ ; do
  244. USERNAME=$(echo "$d" | awk -F '/' '{print $3}')
  245. if [[ $(is_valid_user "$USERNAME") == "1" ]]; then
  246. if ! grep -q '#| /usr/bin/gpgit.pl' /home/$USERNAME/.procmailrc; then
  247. sed -i 's@| /usr/bin/gpgit.pl@#| /usr/bin/gpgit.pl@g' /home/$USERNAME/.procmailrc
  248. sed -i 's|:0 f|#:0 f|g' /home/$USERNAME/.procmailrc
  249. fi
  250. fi
  251. done
  252. if ! grep -q '#| /usr/bin/gpgit.pl' /etc/skel/.procmailrc; then
  253. sed -i 's@| /usr/bin/gpgit.pl@#| /usr/bin/gpgit.pl@g' /etc/skel/.procmailrc
  254. sed -i 's|:0 f|#:0 f|g' /etc/skel/.procmailrc
  255. fi
  256. }
  257. # NOTE: deliberately no exit 0